/*
 File: rhs_bnd.h
 Date and Time: Fri Jan 30 18:55:22 2015 
*/
#ifndef __rhs_bnd_h__
#define __rhs_bnd_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"
extern yacco2::Thread_entry ITH_rhs_bnd;

extern yacco2::State S1_Crhs_bnd;
namespace NS_rhs_bnd {
yacco2::THR _YACCO2_CALL_TYPE
TH_rhs_bnd(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_rhs_bnd(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[1];
};
class Crhs_bnd: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rrhs_bnd_ = 569//start_of_rule_list + 0
    ,rhs1_Rrhs_bnd_ = 1
    ,rhs2_Rrhs_bnd_ = 2
    ,rhs3_Rrhs_bnd_ = 3
    ,rhs4_Rrhs_bnd_ = 4
  };
  //no of la sets = 1
  //no of states = 6
  Crhs_bnd();
  ~Crhs_bnd();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[5];
 };
struct Rrhs_bnd;
struct Rrhs_bnd:public yacco2::CAbs_lr1_sym {
  Rrhs_bnd(yacco2::Parser* P);
  void op();
  public:
  void sr4();
};

} // end of namespace

#endif
